SystemOrganization addCategory: #'AL-Storage'!

Notification subclass: #ALStorageNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

ALStorageNotification subclass: #ALAddEntity
	instanceVariableNames: 'entity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALAddEntity class methodsFor: 'signaling' stamp: 'cwp 11/24/2012 23:26'!
entity: anEntity
	^ (self withEntity: anEntity) signal! !

!ALAddEntity class methodsFor: 'instance creation' stamp: 'cwp 11/24/2012 23:26'!
withEntity: anEntity
	^ self basicNew initializeWithEntity: anEntity! !

!ALAddEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:25'!
entity
	^ entity! !

!ALAddEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:09'!
handleWith: anObject
	^ anObject handleAddEntity: self! !

!ALAddEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:25'!
initializeWithEntity: anEntity
	self initialize.
	entity := anEntity! !

ALStorageNotification subclass: #ALCollectEntities
	instanceVariableNames: 'keys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALCollectEntities class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:27'!
keys: aCollection
	^ (self withKeys: aCollection) signal! !

!ALCollectEntities class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:28'!
withKeys: aCollection
	^ self basicNew initializeWithKeys: aCollection! !

!ALCollectEntities methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:16'!
handleWith: anObject
	^ anObject handleCollectEntities: self! !

!ALCollectEntities methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:28'!
initializeWithKeys: aCollection
	self initialize.
	keys := aCollection! !

!ALCollectEntities methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:27'!
keys
	^ keys! !

ALStorageNotification subclass: #ALDeleteEntity
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALDeleteEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:29'!
key: aKey
	^ (self withKey: aKey) signal! !

!ALDeleteEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:29'!
withKey: aKey
	^ self basicNew initializeWithKey: aKey! !

!ALDeleteEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:09'!
handleWith: anObject
	^ anObject handleDeleteEntity: self! !

!ALDeleteEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:29'!
initializeWithKey: aKey
	self initialize.
	key := aKey! !

!ALDeleteEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:28'!
key
	^ key! !

ALStorageNotification subclass: #ALEditEntity
	instanceVariableNames: 'key entity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALEditEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:31'!
key: aKey entity: anEntity
	^ (self withKey: aKey entity: anEntity) signal! !

!ALEditEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:30'!
withKey: aKey entity: anEntity
	^ self basicNew initializeWithKey: aKey entity: anEntity! !

!ALEditEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:30'!
entity
	^ entity! !

!ALEditEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:10'!
handleWith: anObject
	^ anObject handleEditEntity: anObject! !

!ALEditEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:31'!
initializeWithKey: aKey entity: anEntity
	self initialize.
	key := aKey.
	entity := anEntity! !

!ALEditEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:30'!
key
	^ key! !

ALStorageNotification subclass: #ALReadEntity
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALReadEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:32'!
key: aKey
	^ (self withKey: aKey) signal! !

!ALReadEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:32'!
withKey: aKey
	^ self basicNew initializeWithKey: aKey! !

!ALReadEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:10'!
handleWith: anObject
	^ anObject handleReadEntity: self! !

!ALReadEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:32'!
initializeWithKey: aKey
	self initialize.
	key := aKey! !

!ALReadEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:31'!
key
	^ key! !

!ALReadEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2012 16:21'!
keys
	^ {key}! !

ALRelay subclass: #ALStorageRelay
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALStorageRelay class methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:53'!
destination: aRelay repository: aRepository
	^ self basicNew initializeWithDestination: aRelay repository: aRepository! !

!ALStorageRelay methodsFor: 'dispatching' stamp: 'cwp 11/29/2012 16:59'!
do: aBlock
	| dependencies |
	dependencies := Dictionary new.
	aBlock on: ALStorageNotification do: 
		[:n | (n handleWith: self) do: 
			[:v | dependencies at: v key put: v version]].
	^ dependencies! !

!ALStorageRelay methodsFor: 'relaying' stamp: 'cwp 12/22/2012 22:57'!
etagForResponse: response
	| dependencies digest fields |
	dependencies := self do: [ response basicWriteBodyInto: nil writing ].
	dependencies ifEmpty: [^ nil].
	digest := dependencies serialize digest printAsKey.
	fields := response vary.
	fields ifNotNil:
		[(fields includes: 'Accept') ifTrue:
			[digest :=  digest , ',' , response contentType printString]].
	^ ALEtag weak: digest! !

!ALStorageRelay methodsFor: 'dispatching' stamp: 'cwp 11/27/2012 16:19'!
handleAddEntity: aNotification
	ALStorageError signal: 'Can''t create entities during rendering'! !

!ALStorageRelay methodsFor: 'dispatching' stamp: 'cwp 11/27/2012 16:18'!
handleCollectEntities: aNotification
	^ repository collect: aNotification keys! !

!ALStorageRelay methodsFor: 'dispatching' stamp: 'cwp 11/27/2012 16:19'!
handleDeleteEntity: aNotification
	ALStorageError signal: 'Can''t delete entities during rendering'! !

!ALStorageRelay methodsFor: 'dispatching' stamp: 'cwp 11/27/2012 16:19'!
handleEditEntity: aNotification
	ALStorageError signal: 'Can''t modify entities during rendering'! !

!ALStorageRelay methodsFor: 'dispatching' stamp: 'cwp 11/27/2012 16:20'!
handleReadEntity: aNotification
	^ {repository read: aNotification key}! !

!ALStorageRelay methodsFor: 'relaying' stamp: 'cwp 12/22/2012 22:58'!
handleRequest: aRequest
	| response etag match |
	response := repository do: [ destination handleRequest: aRequest ].
	(self shouldTag: response) ifTrue: 
		[etag := self etagForResponse: response.
		etag ifNotNil:
			[match := aRequest ifNoneMatch.
			(match notNil and: [ match tag = etag tag ])
				ifTrue: [response := ALResponse status: 304 reason: 'Not modified']
				ifFalse: [response etag: etag]]].
	^ response! !

!ALStorageRelay methodsFor: 'initialization' stamp: 'cwp 11/25/2012 09:54'!
initializeWithDestination: aRelay repository: aRepository
	self initializeWithDestination: aRelay.
	repository := aRepository! !

!ALStorageRelay methodsFor: 'relaying' stamp: 'cwp 12/19/2012 22:38'!
shouldTag: response
	^ response hasEntity 
		and: [response hasLastModified not 
			and: [response hasEtag not]]! !

!ALStorageRelay methodsFor: 'relaying' stamp: 'cwp 11/25/2012 09:34'!
write: aMessage into: aWriteStream
	repository do: [ destination write: aMessage into: aWriteStream ]! !

!ByteArray methodsFor: '*al-storage-printing' stamp: 'cwp 11/29/2012 16:53'!
printAsKey
	| out |
	out := (String new: self size // 3 * 4) writing.
	self printAsKeyOn: out.
	^ out conclusion
	! !

!ByteArray methodsFor: '*al-storage-printing' stamp: 'cwp 11/29/2012 16:49'!
printAsKeyOn: out
	| alphabet in |
	alphabet := ALUrlStrategy alphabet.
	in := self reading.
	1 to: self size // 3 do: [ :ignore | 
		| byte bits |
		byte := in get.
		bits := byte bitShift: -2.
		out put: (alphabet at: bits + 1).
		bits := (byte bitAnd: 2r00000011) bitShift: 4.
		byte := in get.
		bits := bits bitOr: (byte bitShift: -4).
		out put: (alphabet at: bits + 1).
		bits := (byte bitAnd: 2r00001111) bitShift: 2.
		byte := in get.
		bits := bits bitOr: (byte bitShift: -6).
		out put: (alphabet at: bits + 1).
		bits := byte bitAnd: 2r00111111.
		out put: (alphabet at: bits + 1) ].
	! !

Object subclass: #ALEntityReference
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALEntityReference class methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:56'!
key: aKey
	^ self basicNew initializeWithKey: aKey! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 22:48'!
= other
	^ self species = other species 
		and: [other hasKey: key]! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:04'!
hasKey: aKey
	^ key = aKey! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 22:48'!
hash
	^ key hash! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 22:47'!
initializeWithKey: aKey
	self initialize.
	key := aKey! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2012 10:03'!
key
	^ key! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:03'!
value
	^ ALReadEntity key: key! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:04'!
value: anEntity
	ALEditEntity key: key value: anEntity.
	^ anEntity! !

Object subclass: #ALEntityVariant
	instanceVariableNames: 'key version entity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALEntityVariant class methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2012 16:32'!
key: aKey entity: anEntity
	^ self key: aKey version: 1 entity: anEntity! !

!ALEntityVariant class methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2012 16:25'!
key: aKey version: aVersion entity: anEntity
	^ self basicNew initializeWithKey: aKey version: aVersion entity: anEntity! !

!ALEntityVariant methodsFor: 'accessing' stamp: 'cwp 11/27/2012 16:35'!
edit: anEntity
	^ self class key: key version: version + 1 entity: anEntity! !

!ALEntityVariant methodsFor: 'accessing' stamp: 'cwp 11/27/2012 16:31'!
entity
	^ entity! !

!ALEntityVariant methodsFor: 'initialization' stamp: 'cwp 11/27/2012 16:24'!
initializeWithKey: aKey version: aVersion entity: anEntity
	self initialize.
	key := aKey.
	version := aVersion.
	entity := anEntity! !

!ALEntityVariant methodsFor: 'accessing' stamp: 'cwp 11/27/2012 16:31'!
key
	^ key! !

!ALEntityVariant methodsFor: 'accessing' stamp: 'cwp 11/27/2012 16:31'!
version
	^ version! !

Object subclass: #ALRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

ALRepository subclass: #ALMemoryRepository
	instanceVariableNames: 'variants'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2012 16:35'!
add: anEntity
	| key variant |
	[key := (1 to: SmallInteger maxVal) atRandom.
	variants includesKey: key] 
		whileTrue.
		
	variant := ALEntityVariant key: key entity: anEntity.
	^ variants at: key put: variant.
	! !

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:22'!
collect: keys
	^ keys collect: [:k | self read: k]! !

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2012 16:35'!
delete: key
	variants removeKey: key ifAbsent: []! !

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2012 16:35'!
edit: key value: anEntity
	| old new |
	old := variants 
		at: key 
		ifAbsent: [ALStorageError signal: 'Entity doesn''t exist'].
	new := old edit: anEntity.
	^ variants at: key put: new.
	! !

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2012 16:35'!
initialize
	variants := Dictionary new! !

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2012 16:35'!
read: aKey
	^ variants 
		at: aKey 
		ifAbsent: [ALStorageError signal: 'Entity doesn''t exist']! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:23'!
add: anEntity
	self subclassResponsibility! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:24'!
collect: aCollection
	self subclassResponsibility! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:24'!
delete: aKey
	self subclassResponsibility! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:34'!
do: aBlock
	^ aBlock
		on: ALStorageNotification
		do: [ :n | n handleWith: self ]! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:24'!
edit: aKey value: anEntity
	self subclassResponsibility! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:28'!
handleAddEntity: aNotification
	| key |
	key := self add: aNotification entity.
	aNotification resume: key! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:29'!
handleCollectEntities: aNotification
	| entities |
	entities := self collect: aNotification keys.
	aNotification resume: entities! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:29'!
handleDeleteEntity: aNotification
	self delete: aNotification key.
	aNotification resume! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:29'!
handleEditEntity: aNotification
	self edit: aNotification key value: aNotification entity.
	aNotification resume! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:30'!
handleReadEntity: aNotification
	aNotification resume: (self read: aNotification key)! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:25'!
read: aKey
	self subclassResponsibility! !

Error subclass: #ALStorageError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!
